from src.models.abstract_reference import abstract_reference
from src.models.nomenclature_model import nomenclature_model
from src.models.measurement_unit_model import measurement_unit_model
from src.errors.error_proxy import error_proxy

#
# Класс описание одной строки рецепта
#
class receipe_model(abstract_reference):
    __nomenclature: nomenclature_model = None
    __size: int = 0
    __unit: measurement_unit_model = None
    
    def __init__(self, _nomenclature: nomenclature_model, _size: int, _unit: measurement_unit_model):
        error_proxy.validate(_nomenclature, abstract_reference)
        error_proxy.validate(_unit, abstract_reference)
         
        self.__nomenclature = _nomenclature
        self.__size = _size
        self.__unit = _unit
        
        super().__init__( f"{_nomenclature.name} , {_unit.name} ")
    
    @property
    def nomenclature(self):
        """
            Номенклатура
        Returns:
            _type_: _description_
        """
        return self.__nomenclature
    
    
    @property
    def size(self):
        """
            Размер

        Returns:
            _type_: _description_
        """
        return self.__size
    
    
    @size.setter
    def size(self, value: int):
        self.__size = value
    
    
    @property    
    def unit(self):
        """
           Единица измерения

        Returns:
            _type_: _description_
        """
        return self.__unit    
        
    